// -*- Mode: C++ -*-

// ----------------------------------------------------------------------------
//  crit_sec.cxx
// ----------------------------------------------------------------------------

#ifndef crit_sec_cxx__
#define crit_sec_cxx__

// ----------------------------------------------------------------------------
//  CN[h
// ----------------------------------------------------------------------------

#include <windows.h>


// ----------------------------------------------------------------------------
//  NeBJZNV
// ----------------------------------------------------------------------------

class critical_section
{
  CRITICAL_SECTION  m_cs;

protected:
  critical_section(void) { InitializeCriticalSection(&m_cs); }
  ~critical_section() { DeleteCriticalSection(&m_cs); }

  void enter(void) { EnterCriticalSection(&m_cs); }
  void leave(void) { LeaveCriticalSection(&m_cs); }
};


#endif // crit_sec_cxx__
