// -*- Mode: C++ -*-

// ----------------------------------------------------------------------------
//  map_file.h
// ----------------------------------------------------------------------------

#ifndef map_file_h__
#define map_file_h__

// ----------------------------------------------------------------------------
//  CN[h
// ----------------------------------------------------------------------------

#include <windows.h>


// ----------------------------------------------------------------------------
//  }bvgt@C
// ----------------------------------------------------------------------------

class map_file
{
  HANDLE  m_fmo;
  void  *m_addr;

public:
  map_file(void)
       : m_fmo(NULL),
         m_addr(NULL) { }
  ~map_file() { close(); }

  int create(HANDLE fh, DWORD protect, DWORD size, const char *name);
  int open(DWORD acc, const char *name);
  void close(void);
  void *map(DWORD acc);
  void unmap(void);
};


// ----------------------------------------------------------------------------
//  (Ot) t@C}bsOIuWFNg
// ----------------------------------------------------------------------------

class file_mapping_object
{
  map_file  m_fmo;
  size_t  m_size;

public:
  file_mapping_object(void) { }
  ~file_mapping_object() { close(); }

  int create(const char *name, size_t data_size);
  int open(const char *name);
  void close(void);
  int write(const void *data, size_t write_size);
  int read(void *buf, size_t buf_size);
};


#endif // map_file_h__
