// -*- Mode: C++ -*-

// ----------------------------------------------------------------------------
//  util.h
// ----------------------------------------------------------------------------

#ifndef util_h__
#define util_h__

// ----------------------------------------------------------------------------
//  CN[h
// ----------------------------------------------------------------------------

#include "conf.h"
#include <time.h>
#include <windows.h>


// ----------------------------------------------------------------------------
//  }N
// ----------------------------------------------------------------------------

#define MIN(a, b) ((a) < (b) ? (a) : (b))
#define countof(a) (sizeof(a) / sizeof((a)[0]))


// ----------------------------------------------------------------------------
//  vg^Cv錾
// ----------------------------------------------------------------------------

uint32 get_exe_size(HANDLE fh);

int split_filepath(const char *filepath,
                   char *dir_buf, size_t dir_size,
                   char *fn_buf, size_t fn_size);
int make_filepath(char *buf, size_t buf_size, const char *dir, const char *fn);

void replace_char(char *str, char rep_c, char with);
time_t dosdatetime_to_time_t(uint datetime);


#endif // util_h__
